<?php $scrpt_vrsn_dt  = 'PWS_quakes_load.php|01|2021-04-21|';   # validity test | extra spaces | release 2012_lts
#-----------------------------------------------
#         PWS-Dashboard - Updates and support by 
#     Wim van der Kuil https://pwsdashboard.com/
#-----------------------------------------------
#       display source of script if requested so
#-----------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
        $filenameReal = __FILE__;    #               display source of script if requested so
        $download_size = filesize($filenameReal);
        header('Pragma: public');
        header('Cache-Control: private');
        header('Cache-Control: no-cache, must-revalidate');
        header("Content-type: text/plain");
        header("Accept-Ranges: bytes");
        header("Content-Length: $download_size");
        header('Connection: close');
        readfile($filenameReal);
        return;}

$url            = 'https://www.emsc-csem.org/service/rss/rss.php?typ=emsc'; #
$allowed_age    = 22*60;
$cache          = './jsondata/earthquake.json';

if (file_exists($cache) && !array_key_exists ('force',$_REQUEST) 
  && time() - filemtime($cache) <  $allowed_age ) 
     {  if(! array_key_exists('json',$_REQUEST) ) { die ("all OK");}
        $data   = file_get_contents($cache);
        echo $data.'                 ';
        return; }
#
$ch     = curl_init(); 
curl_setopt($ch, CURLOPT_URL,$url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,5);    // connection timeout
curl_setopt($ch, CURLOPT_TIMEOUT,5);           // data timeout 
curl_setopt ($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.1; rv:12.0) Gecko/20120424 Firefox/12.0 PaleMoon/12.0'); 
$raw_data       = curl_exec ($ch);  
$info	        = curl_getinfo($ch);
$error          = curl_error($ch);
curl_close ($ch);
if ( array_key_exists ('force',$_REQUEST) )
     {  echo '<pre>'.PHP_EOL.'$error = '.$error
        .PHP_EOL.'$info = '.print_r($info,true)
        .PHP_EOL.'$raw_data = '.PHP_EOL.$raw_data
        .PHP_EOL.'</pre>'; }
if (trim($error) <> '' || strlen ($raw_data) < 5000) 
     {  if(! array_key_exists('json',$_REQUEST) ) { die (__LINE__." error $error use old version");}
        $data   = file_get_contents($cache);
        echo $data.'                 ';
        return;} 
#
$levels =  array (4,5,6,7,8,99999999);
$texts  =  array ('Minor','Light','Moderate','Strong','Major','Great');
$raw_data       = str_replace(':','_',$raw_data);
$xml    = simplexml_load_string($raw_data);
$json   = json_encode($xml);
$array  = json_decode($json,TRUE);
$quakes = $array['channel']['item'];  #echo '<pre>'.print_r($quakes,true); #exit;
$new_arr= array();
foreach ($quakes as $quake)
     {  $arr    = array();
        $check  = $quake['emsc_magnitude'];
        $locat  = trim( str_replace ($check, '',$quake['title']) );
        $magn   = preg_replace("/[^0-9.]/", "",$check);
        $depth  = preg_replace("/[^0-9.]/", "",$quake['emsc_depth']);
        $date_tm= str_replace(' UTC','+00:00',$quake['emsc_time']);
        $date_tm= str_replace('_',':',$date_tm);
        $date_tm= str_replace(' ','T',$date_tm);
        $unix   = strtotime($date_tm);
        foreach ($levels as $key => $level)
                { if ( (float) ($magn ) < $level) {$text = $texts[$key]; break;}
                  } 
        $arr['title']           = $text. ' earthquake - '.$locat.' - '.gmdate ('F j, Y',$unix); 
        $arr['magnitude']       = $magn; 
        $arr['location']        = $locat;
        $arr['depth']           = preg_replace("/[^0-9.]/", "",$quake['emsc_depth']);
        $arr['latitude']        = $quake['geo_lat'];
        $arr['longitude']       = $quake['geo_long'];
        $arr['date_time']       = $date_tm;
        $arr['link']            = str_replace('_',':',$quake['link']);
        $new_arr[]      = $arr;
        }
if (count ($new_arr) < 10)
     {  if(! array_key_exists('json',$_REQUEST) ) { die (__LINE__." use old version nor enough data");}
        $data   = file_get_contents($cache);
        echo $data.'                 ';
        return;} 
#
$data   = json_encode ($new_arr);
file_put_contents ($cache, $data);
if(! array_key_exists('json',$_REQUEST) ) { die ("succes, saved");}
echo $data.'                 ';
return;
