<?php $scrpt_vrsn_dt  = 'ccn_aeris_block.php|01|2021-05-25|';  # check data + translation | release 2012_lts
#-----------------------------------------------
# ccn_aeris_block
# |-> PWS_livedata.php
# |-> fct_aeris_shared_hrs.php  = 1 hour forecast and translate tables / functions
# |-> if the icon and condition text are not 
#     available from another script those fields are used from ccn array
# |-> The hourly forecasts are read until the next-hour forecast
#     |-> the correct hourly fct is used
# |-> ccn_shared.php    to print all info
#-----------------------------------------------
#         PWS-Dashboard - Updates and support by 
#     Wim van der Kuil https://pwsdashboard.com/
#-----------------------------------------------
#       display source of script if requested so
#-----------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;  
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header('Content-type: text/plain; charset=UTF-8');
   header('Accept-Ranges: bytes');
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;}
elseif (!isset ($_REQUEST['test'])) 
     {  ini_set('display_errors', 0);   error_reporting(0);}
# -------------------save list of loaded scrips;
if (!isset ($stck_lst) ) {$stck_lst = '';}
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') version =>'.$scrpt_vrsn_dt.PHP_EOL;       
#
# ------------check if script is already running
$string = str_replace('.php','',basename(__FILE__));
if (isset ($$string) ) {echo 'This '.$$string.' info is already displayed'; return;}
$$string = $string;
#
# -------------load weatherdata and all settings 
$scrpt          = 'PWS_livedata.php'; 
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') include_once =>'.$scrpt.PHP_EOL;
include_once $scrpt;  
#
# -----------------   load general Aeris code
$one_hour_only  = true;
$scrpt          = 'fct_aeris_shared_hrs.php';
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') include_once  =>'.$scrpt.PHP_EOL; 
include_once $scrpt;
$message        = '';
if   (!isset ($parts) 
   || !is_array ($parts)
   || !array_key_exists (0,$parts) )
     {  echo  '<p style="color: red;">No valid data-file found</p>';
        return;}
$arr    = $parts[0]; 
#
#-----------------------------------------------
#  save condition icon and texts for current  block
#        if not already generated by another script
#
if (!isset ($timeXX) ) { 
#          load current conditions file
        $ars_ccnt_fl    = 'aeris_ccn.json';  // metar data
        $data_ccn = null;
        if (file_exists ($fl_folder.$ars_ccnt_fl))
             {  $json           = file_get_contents($fl_folder.$ars_ccnt_fl);
                $data_ccn       = json_decode($json, true); } # echo '<pre>json data'.print_r($data_ccn, true) ; exit;    
        if ($data_ccn == null) { echo '<small style="color: red;"><b>invalid data</b><br />'.$ars_ccnt_fl.'</small>'; return;}
        $ccn            = $data_ccn['response']['ob']; 
        if (isset ($_REQUEST['test']) ) {echo '<!-- '.basename(__FILE__).' ('.__LINE__.') '.print_r($ccn,true).' -->'.PHP_EOL; }
        $timeXX         = $ccn['timestamp'];   
        $original       = $ccn['weather'];
        $translated = '';                                       #### 2020-12-09 
        $blocks = explode ('with',$original); 
        foreach ($blocks as $key => $block)
             {  $or_BL  = trim ($block);
                $tr_BL  = lang ($or_BL);
                if ($or_BL == $tr_BL)           // no full translation found => translate words
                     {  $words  = explode (' ',$or_BL); 
                        foreach ($words as $key => $word) { $translated .= lang ($word).' ';}
                        $translated = trim($translated);}
                else {  $translated .= $tr_BL;}
                $translated .= '#';}
        $translated = substr($translated,0,-1);
        $translated = str_replace ('#',' , ',$translated);      #### 2020-12-09 
        $textXX         = $translated;
        $stck_lst      .= basename(__FILE__).' ('.__LINE__.') conditions from provider ='.$textXX.PHP_EOL;
        $look           = str_replace ('.png','',$ccn['icon']);
        $icon           = icon_trns_hrs ($look);
        $iconXX         = './pws_icons/'.$icon.'.svg';
        $stck_lst      .= basename(__FILE__).' ('.__LINE__.') icon from provider data ='.$iconXX.PHP_EOL;
        #
        if (isset ($ccn_small) ) { return;}
     }  // eo if not already generated by another script
#
# --------------   find current hour or use last
#
$hourlySummary          = $arr['desc'];
$num                    = 
$hourlyTemp             = $arr['temp'];
$tempC                  = convert_temp ($hourlyTemp,$tempunit,'c',0); 
#
$num2                   = $arr['feel'];  
if ($num2 > $num)
     {  $chillC         = '';
        $hourlychill    = '';
        $hourlyhudx     = $num2;  
        $hudxC          = $num2;}
else {  $hudxC          = '';
        $hourlyhudx     = '';
        $hourlychill    = $num2;  
        $chillC         = $num2; }
# save as debug info  
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') $hourlyTemp='.$hourlyTemp.' $hourlychill='.$hourlychill.' $hourlyhudx='.$hourlyhudx.PHP_EOL;
#
#$hourlyWinddir          = $cond['windBearing'];
$hourlyPrecipProb       = $arr['r_ch'];
$hourlyPrecipType       = 'rain';
$hourlyprecipIntensity  = 0;
$hourlyWindSpeed        = $arr['wspd'];
$hourlyWindGust         = $arr['gust'] ;
$hourlyuv               = $arr['uvuv'];
#
#-----------------------------------------------
# After all current condition fields are ready
# we use another general script to print them   
$scrpt          = 'ccn_shared.php';
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') include_once  =>'.$scrpt.PHP_EOL; 
include_once $scrpt;
#
if (isset ($_REQUEST['test']) ) { echo '<!-- '.PHP_EOL.$stck_lst.'-->'.PHP_EOL; $stck_lst='';}
